local addonName, RS = ...
RS.Events = RS.Events or {}
local Events = RS.Events

----------------------------------------------------------------------------------------------------
-- settings are loaded - watching for Blizzard addons to load
----------------------------------------------------------------------------------------------------
function Events:ADDON_LOADED(name)
	if name == addonName then
		RS.Settings:Load()
		self:SetNextAutomaticTime()

		for _,subtables in pairs(RS) do
			if type(subtables) == "table" and subtables.OnLoad then
				subtables:OnLoad()
			end
		end
	elseif name == "Blizzard_InspectUI" then
		hooksecurefunc("InspectFrame_Show", function()
			local name = InspectFrame.unit and UnitName(InspectFrame.unit)
			if name then
				RS.Reactions.AttemptReaction("InspectPlayer", 0, nil, name, nil, RS.Common.ActionType.HIT)
			end
		end)
	end
end

--------------------------------------------------
-- logging in/reloading
-- real login: player_login -> player_entering_world -> player_alive -> update_pending_mail
-- reloadui  : player_login -> player_entering_world -> update_pending_mail
--------------------------------------------------
function Events:UPDATE_INSTANCE_INFO()
	self.eventFrame:UnregisterEvent("UPDATE_INSTANCE_INFO")
	self.eventFrame:UnregisterEvent("PLAYER_ALIVE")

	self.hasLoggedIn = true
	self.inGroup = IsInGroup()
	self.isDead = UnitIsDeadOrGhost("player")
	self.lowestDurability = RS.Common.GetLowestEquipmentDurability() or 100
	GuildRoster()
	C_FriendList.ShowFriends()

	if ReactionsSave.enabled then
		self:RegisterReactionsEvents()
		if self.isRealLogin then
			RS.Reactions.AttemptReaction("Login", 0, nil, playerName, nil, RS.Common.ActionType.HIT)
		end
	end
end

-- register loading events
Events.eventFrame:RegisterEvent("ADDON_LOADED")
Events.eventFrame:RegisterEvent("PLAYER_ALIVE")
Events.eventFrame:RegisterEvent("UPDATE_INSTANCE_INFO")

